Subject: Re: bug#55877: 29.0.50; list-directory doesn't allow globbing interactively

From: Eli Zaretskii <[email-masked]>
Date: Sat, 11 Jun 2022 19:55:41 +0300

> Cc: [email-masked]
> From: chad <[email-masked]>
> Date: Sat, 11 Jun 2022 12:38:53 -0400
> 
> Sorry, I was probably unclear, and my earlier hack-around was no good. The first call to list-directory works
> fine. It's the followup, issued from the buffer of the first, that raises the problem, because default-directory in
> the buffer of the first call is set to, in your example, /tmp/*/, and call-process balks when default-directory
> doesn't exist.  To repeat, from a fresh emacs -Q:
> 
> `C-x C-d /tmp/*/ RET C-x 0 C-x C-d /tmp/ RET'.
> 
> I see "insert-directory: Setting current directory: No such file or directory, /tmp/*/" in *Messages* in emacs
> -Q. (In practice, with a fresh emacs -Q, sometimes I also get the same error from
> comp-run-async-workers, if it triggers when I'm in that buffer, which was a surprise.) 
> 
> I suspect this is due to the explicit setting of default-directory at the end of list-directory:
> 
> >    ;; Finishing with-output-to-temp-buffer seems to clobber default-directory.
> >    (with-current-buffer buffer
> >       (setq default-directory
> >               (if (file-directory-p dirname)
> >                   (file-name-as-directory dirname)
> >                  (file-name-directory dirname))))
> 
> In the above test case, dirname ends up as "/tmp/*/", which falls through file-directory-p and ends up passed
> to file-name-directory, which just returns it unchanged under unix, because of the trailing slash. This is a
> mirror to the logic up-function that checks for wildcards (insert-directory-wildcard-in-dir-p, etc). I considered
> ways to pass down that information or recreate it, but I don't (yet?) have a better answer for what value it
> should have than "something safe" or "try to munge the wildcard into an existing directory", which seems
> terrible. Maybe the right answer is to not setq default-directory at all unless dirname is file-directory-p?

Does the below fix the problem?

diff --git a/lisp/files.el b/lisp/files.el
index 75a856c..aacc1cd 100644
--- a/lisp/files.el
+++ b/lisp/files.el
@@ -7406,9 +7406,9 @@ list-directory
     ;; Finishing with-output-to-temp-buffer seems to clobber default-directory.
     (with-current-buffer buffer
       (setq default-directory
-	    (if (file-directory-p dirname)
+	    (if (file-accessible-directory-p dirname)
 		(file-name-as-directory dirname)
-	      (file-name-directory dirname))))))
+	      (file-name-directory (directory-file-name dirname)))))))
 
 (defun shell-quote-wildcard-pattern (pattern)
   "Quote characters special to the shell in PATTERN, leave wildcards alone.